# DeepDetect: Open Source Deep Learning Server & API (Changelog)

## 0.13.0 (2021-01-22)


### Features

* support for batches for NCNN image models ([b85d79e](https://github.com/jolibrain/deepdetect/commit/b85d79e673ac28d0f1bcf65a1773990bff6cd0b4))
* **ml:** retain_graph control via API for torch autograd ([d109558](https://github.com/jolibrain/deepdetect/commit/d109558f20c7aba2eda6ef16eb884845bf816638))
* **ml:** torch image basic data augmentation ([b9f8525](https://github.com/jolibrain/deepdetect/commit/b9f85251380c0483268488c07990db3a68f5a4ee))
* **ncnn:** use master from tencent/ncnn ([044e181](https://github.com/jolibrain/deepdetect/commit/044e1811223c1c6843a35363cf4b29aed5394003))
* upgrade oatpp to pre-1.2.5 ([596f6f4](https://github.com/jolibrain/deepdetect/commit/596f6f4c4098468ff3b2f3276bf5e6f8043edb27))


### Bug Fixes

* **torch:** csvts forecast mode needs sequence of length backcast during predict ([4c89a1c](https://github.com/jolibrain/deepdetect/commit/4c89a1c0e22a34afaf2433e675fb7fb9a32add43))
* add missing spdlog patch ([4d0a4fa](https://github.com/jolibrain/deepdetect/commit/4d0a4fa1f281a1ab2067a3801ed49c0122c604a7))
* caffe linkage with our spdlog ([967fdef](https://github.com/jolibrain/deepdetect/commit/967fdefb4497b71b3274ade8d64f50c019f3f034))
* copy .git in docker image builder ([570323d](https://github.com/jolibrain/deepdetect/commit/570323d91518bb2f62e7555da80549e6521598cf))
* deactivate the csvts NCNN test when caffe is not built ([5a5c8f1](https://github.com/jolibrain/deepdetect/commit/5a5c8f12227a629f656ca016e28d2a9f35d1e3d1))
* missing support for parent_id in chains with Python client ([a5fad50](https://github.com/jolibrain/deepdetect/commit/a5fad50b2c698418f81cab9d714e4ddd13081839))
* NCNN chain with images and actions ([38b1d07](https://github.com/jolibrain/deepdetect/commit/38b1d076ddddac0ef126e0eb63f08e019b62f15c))
* throw if hard image read error in caffe classification input ([f1c0d09](https://github.com/jolibrain/deepdetect/commit/f1c0d09d511ea63f65def260cce5577455fb897e))
* **doc:** similarity search_nn number of results API ([5eaf343](https://github.com/jolibrain/deepdetect/commit/5eaf3435d39db77ee0a4fed725eb257718805a45))
* **torch:** remove potential segfault in csvts connector ([ba96b4e](https://github.com/jolibrain/deepdetect/commit/ba96b4ea4ff6315194e0d9150934a380bbac265e))

## 0.12.0 (2021-01-08)


### Features

* switch back to cppnet-lib by default ([ebe3b15](https://github.com/jolibrain/deepdetect/commit/ebe3b15e7e3065727b4649b605c83caf8a53dc70))
* **torch:** native models can load weights from any jit file ([69af7f4](https://github.com/jolibrain/deepdetect/commit/69af7f4b7279dc192b3772271fef2682ca9df36f))
* **torch:** update libtorch to 1.7.1 ([41d5375](https://github.com/jolibrain/deepdetect/commit/41d5375961a4f7d62c716f7d010a480e566e1ca6))
* add access log for oat++ ([4291bf8](https://github.com/jolibrain/deepdetect/commit/4291bf8db2030aa5f07ef0a87ef6207b39004845))
* add cudnn cmake find package ([5983ffd](https://github.com/jolibrain/deepdetect/commit/5983ffdc7551605118e7b5cd17e7faaa05e7f45a))
* add some more error messages to log ([e4ec772](https://github.com/jolibrain/deepdetect/commit/e4ec7728424b1d593141923a093079f7d84b3460))
* enable backtrace on segfault for oatpp ([96b2184](https://github.com/jolibrain/deepdetect/commit/96b2184656eb54d2e14d7277a44080a649f7fe40))
* enhance cppnetlib req timing logs ([6fc3e76](https://github.com/jolibrain/deepdetect/commit/6fc3e76f5b156161c1f695cfe688c7b215cecda4))
* gives also per target error and not only global eucl when selecting measure:eucll ([dd2fc79](https://github.com/jolibrain/deepdetect/commit/dd2fc794be77aefc0690d1cf772c24f8f688daa1))
* introduce aotpp interface for deepdetect ([04b79f4](https://github.com/jolibrain/deepdetect/commit/04b79f47bf3932ab25a33aaab2bce11212b1c3d4))
* print stacktrace on segfault ([11ab359](https://github.com/jolibrain/deepdetect/commit/11ab359a35c9faf1264a6763ac19e61bcd269a4a))
* provide predict/transform duration in ms ([0197991](https://github.com/jolibrain/deepdetect/commit/0197991b6d5044a9ad41f18647de2483260fc96b))
* service stats provide predict and transform duration total ([9a24125](https://github.com/jolibrain/deepdetect/commit/9a24125e5916a29f7f3f3842134552a0e83c1be7))
* track oatpp request timing ([68749d3](https://github.com/jolibrain/deepdetect/commit/68749d398177bbde66f08740ec9e38568f557c25))
* **ml:** image regression model training with libtorch ([968c551](https://github.com/jolibrain/deepdetect/commit/968c5512bb72ba49e91fe25bbb38879b4eb5e90f))
* **tools:** trace_torchvision can trace models for loading weights with dd native models ([c11b551](https://github.com/jolibrain/deepdetect/commit/c11b551e0a6ac4507aa894ac76c9410852e97fd6))
* **torch:** Add multigpu support for native models training ([33cd1df](https://github.com/jolibrain/deepdetect/commit/33cd1df023585917acb7e1fd0719859c52bb2c22))
* **torch:** Add native resnet support ([0a01e57](https://github.com/jolibrain/deepdetect/commit/0a01e57a204fc8af815eafe42372515565431111))
* **torch:** add wide resnet and resnext to the vision models ([aba6efb](https://github.com/jolibrain/deepdetect/commit/aba6efbf20a3af4f54315ca5764931acf39e9b71))
* use jolibrain fork of faiss ([8eb6e53](https://github.com/jolibrain/deepdetect/commit/8eb6e537d24f7da74bca111d726f15b2f5f99a30))
* use oatpp by default ([c1d6620](https://github.com/jolibrain/deepdetect/commit/c1d66202768a9b72ee6a30664ac423015c8f19f3))
* vision transformer (ViT) multi-gpu with torch ([88b65c2](https://github.com/jolibrain/deepdetect/commit/88b65c293295b3c56319914806bebeef922f0162))
* **graph:** correct data size computation if different ouputs of an op have different sizes ([288dd5b](https://github.com/jolibrain/deepdetect/commit/288dd5be22b5de83719043dd6ecedc095c75e16c))
* **ml:** added vision tranformer (ViT) as torch native template ([72c0269](https://github.com/jolibrain/deepdetect/commit/72c02696a64d7309ecd2b94b1142fe55fe2dd641))
* **ml:** torch db stores encoded images instead of tensors ([e7f3c19](https://github.com/jolibrain/deepdetect/commit/e7f3c19047dde87c5ec0ccb06d22395b5707fca2))
* **ml:** torch regression and classification models training from list of files without db ([e049caa](https://github.com/jolibrain/deepdetect/commit/e049caacc6f3cae7f1d286b224a295a95ab801e3))
* **torch:** clip gradient options for all optimizers ([c2ddee5](https://github.com/jolibrain/deepdetect/commit/c2ddee510a6ce68d5615449744ad0e3c7ae79e48))
* **torch:** implement resume mllib option for torchlib: if true, reuse previous solver state ([02e3177](https://github.com/jolibrain/deepdetect/commit/02e3177ef77ef1cec506ab683b26b16963339d32))
* **torch/nbeats:** allow different sizes for backcast and forecast , also implements minimal change in csvtstorchinputconn in order to do forecast of signals instead of label predicting ([d4e27f3](https://github.com/jolibrain/deepdetect/commit/d4e27f37b721f9ac5e9fd8932ddde2622ce5c3d0))
* **torch/timeseries:** add (p)ReLU layers in recurrent template, allowing to compute mlp-like embeddings before LSTM layers ([930bee2](https://github.com/jolibrain/deepdetect/commit/930bee21b1cc3b107a7290c000f016be35fc6bdd))
* **torch/timeseries:** log much more info on data ([17d9a49](https://github.com/jolibrain/deepdetect/commit/17d9a49932c9c76fe49d824beb5ab33b209e9060))
* allow to disable warning on build ([75b2928](https://github.com/jolibrain/deepdetect/commit/75b2928fbd40c1c7de53ba5d8107afd058dbdca4))
* one protobuf to rule them all ([37a0867](https://github.com/jolibrain/deepdetect/commit/37a08671718b96a6e27150b9d479eff9b2ac36eb))


### Bug Fixes

* allows mean+std image transform with NCNN inference ([c038f47](https://github.com/jolibrain/deepdetect/commit/c038f47649afa5a529cb7ec98b6c83dd7c595bd4))
* benchmark tool to pass input size on every predict call ([997023a](https://github.com/jolibrain/deepdetect/commit/997023a7ea49ce5b69d0433830850a499aee9c1e))
* bounds on two ml tests with non deterministic outputs ([eeb783a](https://github.com/jolibrain/deepdetect/commit/eeb783a9929bb8c4282ab079b3448429b6c2b009))
* broken API doc formatting ([8b0ab32](https://github.com/jolibrain/deepdetect/commit/8b0ab32c26c0a9ae6d1bec40c12a6825fb49eb07))
* caffe backend internal exception if bbox rescaling fails ([47d589f](https://github.com/jolibrain/deepdetect/commit/47d589fa28877f01150b27a32bc75eaeba30873c))
* copy oatpp static files in docker images ([d6568d8](https://github.com/jolibrain/deepdetect/commit/d6568d86572fa5969eac1dc70912e8b6972dd8d8))
* copy service name between input and output rapidjson document ([46456dd](https://github.com/jolibrain/deepdetect/commit/46456dd3cb2554a34bca9eac77f34462e724e5a7))
* ddimg logger ptr ([4e9e871](https://github.com/jolibrain/deepdetect/commit/4e9e871dd80d5f68227dadb1ba4226bb4519420d))
* do not display all euclidean metrics for autoencoders ([8e09e48](https://github.com/jolibrain/deepdetect/commit/8e09e48ffaf7f9419a2c6dc0e76f2ec1267f4285))
* ensure redownloaded test archives are extracted ([d09eb2a](https://github.com/jolibrain/deepdetect/commit/d09eb2a69a5fe0a536ae7730327a4e451bf7693e))
* fix compilation w/o caffe ([0e693c5](https://github.com/jolibrain/deepdetect/commit/0e693c506cfbe9a44a0b72afc6012cc27c647248))
* forward our cuda to xgboost ([021b5a8](https://github.com/jolibrain/deepdetect/commit/021b5a890c9d6b2d215eafa490468d9af68a5ac1))
* init XXX_total_duration_ms to 0ms ([292d891](https://github.com/jolibrain/deepdetect/commit/292d89189e6c7559094faadeff1b71c16fc771b7))
* missing libboost-stacktrace-dev dep in docs ([37e6008](https://github.com/jolibrain/deepdetect/commit/37e6008bd02912b99dabd637059916bd1563fd00))
* models flops and number of parameters in API ([b856534](https://github.com/jolibrain/deepdetect/commit/b856534b47dfd2e5060a31789f35d956e96d6671))
* NCNN backend using the common protobuf ([a8dc531](https://github.com/jolibrain/deepdetect/commit/a8dc531554d658dedd0d0660938aaff58e47fca8))
* NCNN bbox loop ([8d029c9](https://github.com/jolibrain/deepdetect/commit/8d029c97cc4ef6bcad15e8a9f3af00c7bbb0ea4c))
* NCNN best parameter for classification models ([a7ac187](https://github.com/jolibrain/deepdetect/commit/a7ac187213927a5b20b61c3a9b0a98123cdfc08a))
* ONNX tensorrt engine with correct enqueueV2 ([1aede85](https://github.com/jolibrain/deepdetect/commit/1aede8543f05be602f77df6bfb93310fcf8cee1a))
* pass CUDA_ARCH correctly to caffe ([3b9f5a1](https://github.com/jolibrain/deepdetect/commit/3b9f5a1b4c7e8e2957d543fd48da02ef907c3bb4))
* raise error is jsonapi is invalid ([0e0a892](https://github.com/jolibrain/deepdetect/commit/0e0a8928bea745ef349b2d5857d848eb56a4d0e8))
* refinedet vovnet deploy parameter setup ([d7ff1e6](https://github.com/jolibrain/deepdetect/commit/d7ff1e6fe00c9b3fe79d4d88f3f7db39c4ba8b68))
* reraise same signal on abort ([391568d](https://github.com/jolibrain/deepdetect/commit/391568d7e87e9be3f900f04c127dc0154d62dc79))
* scale image input with NCNN ([49cddfe](https://github.com/jolibrain/deepdetect/commit/49cddfed895a6f32f7359b07f6fd12b28c6aeb7c))
* setuptools drop support of python27 ([71cd789](https://github.com/jolibrain/deepdetect/commit/71cd789a96f900b1badbed2bfb5b8dededebfb74))
* simsearch build with annoy ([39a9cda](https://github.com/jolibrain/deepdetect/commit/39a9cda67291cee76b4e3e6d19e8411161a8f2f1))
* some HTTP return codes ([703553f](https://github.com/jolibrain/deepdetect/commit/703553f4bde76f44721a963efca2317b444a1c86))
* start-dede.sh permissions ([66b49c4](https://github.com/jolibrain/deepdetect/commit/66b49c4e71244b38e5c651945e0b6f9bcaa8ff6b))
* tensorrt input size for caffe source models ([5488c99](https://github.com/jolibrain/deepdetect/commit/5488c99bbc4450db7c3c7b447b2168e96d377c40))
* tensorrt max workspace size overflow ([0358c4a](https://github.com/jolibrain/deepdetect/commit/0358c4a0e236969b3840832271f1a709d5318507))
* tentative torch faster tests ([cbdefa7](https://github.com/jolibrain/deepdetect/commit/cbdefa7f78ec40b822ad9f65bb3dda83ea8bbd71))
* torch image input connector mean and std scaling ([13374dd](https://github.com/jolibrain/deepdetect/commit/13374dd096d9634ab382c91883225919d551e4a6))
* wrong NCNN bbox output scaling ([113c7d2](https://github.com/jolibrain/deepdetect/commit/113c7d2fda6c4ea2c787b1d3b043814c7c27a4f7))
* wrong template_params with torch from DD API ([bee39c4](https://github.com/jolibrain/deepdetect/commit/bee39c46ff65e4762aa0ec059bd161c3d417d162))
* **build:** allow cmake 3.10 (Ubuntu 18.04) for builds with -DUSE_CPU_ONLY=ON ([d6fff8d](https://github.com/jolibrain/deepdetect/commit/d6fff8d5fa01fb367232b326aa07d5c6472051eb))
* **build:** fix tensorrt-oss include ([bdf4ec2](https://github.com/jolibrain/deepdetect/commit/bdf4ec2dfd5e2f99863c0df66e2eb5373c9ebdb9))
* **caffe:** check model destination permissions ([913489e](https://github.com/jolibrain/deepdetect/commit/913489ead563d3b69859a71e205dde889ac1724a))
* **csv:** remove trailing \n from header if there are any, robustify in case of data passed from mem ([400b53a](https://github.com/jolibrain/deepdetect/commit/400b53a70d32ef8713ab47c7f2f8584cbce2e1de))
* **csvts:** clarify error msg on seq lenths ([ad99049](https://github.com/jolibrain/deepdetect/commit/ad99049b45493fd4515da59e521f9eb8823db8db))
* **csvts:** fix typo in logged msg ([a81b291](https://github.com/jolibrain/deepdetect/commit/a81b29114998ae3c94fc23d234ecc862ba80bf78))
* **nbeats:** fix for multi gpu ([627c8db](https://github.com/jolibrain/deepdetect/commit/627c8dbe96c207bf31b56d8fd3f4d9fb57bcfa99))
* **nbeats:** fix loss for backcast part ([986728c](https://github.com/jolibrain/deepdetect/commit/986728cfaf3a39f85c4922f51ac225470a966ab5))
* **oatpp:** use parent _logger object ([88fc246](https://github.com/jolibrain/deepdetect/commit/88fc24699130ac8466c788fb0b9d956f19b36006))
* **timeseries:** throw exception if recurrent template w/o layers specification ([efc49de](https://github.com/jolibrain/deepdetect/commit/efc49dec7f47d5024d4a0626930fffa40cbf32ba))
* **timeseries:** throw if smthg wrong with scaling values ([bf316b9](https://github.com/jolibrain/deepdetect/commit/bf316b979b51c9075cb32e48fbd53c1129f9418b))
* **torch:** also remove not best models in case of native model ([45819df](https://github.com/jolibrain/deepdetect/commit/45819df230f952531723c5a13999702bdfca996a))
* **torch:** correctly implements range state comparison ([c58a0df](https://github.com/jolibrain/deepdetect/commit/c58a0df148924801d59e3024ec5bba0f4c99103f))
* **torch:** Display correct remaining time and iteration duration ([ec7c031](https://github.com/jolibrain/deepdetect/commit/ec7c03138a62004d347c639b0146cf2c0d01a0fb))
* **torch:** do not add linear head if native model ([f81b997](https://github.com/jolibrain/deepdetect/commit/f81b99759dd70e226246bc59f49392de3434761f))
* **torch:** loosen ut test ([30659c8](https://github.com/jolibrain/deepdetect/commit/30659c8194e9b285b33c7238bce409ec41ecdf92))
* **torch:** loosen ut test 2 ([ad6da05](https://github.com/jolibrain/deepdetect/commit/ad6da05d0e8900c369a70e7f9b17b436f4a13c6a))
* **torch:** when resume, override solver parameters after solver reload ([d08695d](https://github.com/jolibrain/deepdetect/commit/d08695da574b69e8461c1bc9ebe89ea6cbf4b922))
* **torch/timeseries:** restore previous behavior wrt timesteps API param : timestep not used at predict time ([a343d4b](https://github.com/jolibrain/deepdetect/commit/a343d4b70da4d5ade17cd7f381a308ec875d2074))
* ViT blocks modification for importing pre-trained models ([f7f66a4](https://github.com/jolibrain/deepdetect/commit/f7f66a47aa51e018f22381da7c7decef0de233bf))
* **torch/timeseries:** check if number of labels is not larger than number of columns ([294a5ed](https://github.com/jolibrain/deepdetect/commit/294a5ed30a9e7ea755cd6638c8c827a82aa589ca))
* **ViT:** typo that changed computations a lot ([95acf05](https://github.com/jolibrain/deepdetect/commit/95acf0571b0df4931493899adf606c16e8bf5a10))
* tensorrt refinedet CI and linking to nvcaffeparsers with tensorrt OSS ([846d6f5](https://github.com/jolibrain/deepdetect/commit/846d6f56aedb45abe0d5393be383c5d35a75a129))
* **torch/native:** do not fail if trying to load weights before (late) allocation of native model ([e0e1d9b](https://github.com/jolibrain/deepdetect/commit/e0e1d9b67c4a55bc0f85fb63e380d46b1956bd9f))

## 0.11.0 (2020-11-10)


### Features

* **bench:** support for regression model benchmarking ([a385292](https://github.com/jolibrain/deepdetect/commit/a385292f708fa3a58b680a5c08f8671211b9f456))
* make python client an install package ([ec2f5e2](https://github.com/jolibrain/deepdetect/commit/ec2f5e27470371d995e640d1f6c2722d08415051))
* one protobuf to rule them all ([77912fe](https://github.com/jolibrain/deepdetect/commit/77912fed039067b6124326dfe3ac22957d2d430c))
* **api:** add versions and compile flags to /info ([67b1d99](https://github.com/jolibrain/deepdetect/commit/67b1d992d029962b879512614bea353df9b9abfb)), closes [#897](https://github.com/jolibrain/deepdetect/issues/897)
* **caffe:** add new optimizers flavors to API ([d534a16](https://github.com/jolibrain/deepdetect/commit/d534a16e56ecc7366ee109a4d4fefdf5873c5f0e))
* **ml:** tensorrt support for regression models ([77a016b](https://github.com/jolibrain/deepdetect/commit/77a016b12cea8126ea96b1173a0116817591a8e9))
* **tensorrt:** Add support for onnx image classification models ([a8b81f2](https://github.com/jolibrain/deepdetect/commit/a8b81f2f20c8d9d2ac2268d1542412dd46c9e001))
* **torch:** ranger optimizer (ie rectified ADAM + lookahead) + \ ([a3004f0](https://github.com/jolibrain/deepdetect/commit/a3004f068fe92ddddab0905c0587aaac1a129378))


### Bug Fixes

* **torch:** best model was never saved on last iteration ([6d1aa4d](https://github.com/jolibrain/deepdetect/commit/6d1aa4d7b7110455d403d60cfb36331abe4bf863))
* **torch:** clip gradient in rectified adam as stated in annex B of original paper ([1561269](https://github.com/jolibrain/deepdetect/commit/1561269ae8b83eafee16a7867764430c5fe7f27e))
* **torch:** Raise an exception if gpu is not available ([1f0887a](https://github.com/jolibrain/deepdetect/commit/1f0887aaf379d069d7418848f7f0fb59b9c400d2))
* add pytorch fatbin patch ([43a698c](https://github.com/jolibrain/deepdetect/commit/43a698cd52fd24ab4139146eec4becca618f903f))
* add tool to generate debian buster image with the workaround ([5570db4](https://github.com/jolibrain/deepdetect/commit/5570db4574626f820d759d2d4e0f8092ede1c879))
* building documentation up to date for 18.04, tensorrt and tests ([18ba916](https://github.com/jolibrain/deepdetect/commit/18ba916e2c82427f08dbbfaea792fa3fc8a91430))
* docker adds missing pytorch deps ([314160c](https://github.com/jolibrain/deepdetect/commit/314160c49aaa41f06a47bbb3d44cc6d38f6d5530))
* docker build readme link from doc ([c6682bf](https://github.com/jolibrain/deepdetect/commit/c6682bfa7eb5ec7ef8c495056cb5fe6e4b7b7eac))
* handle int64 in conversion from json to APIData ([863e697](https://github.com/jolibrain/deepdetect/commit/863e697283ab4853714bdd36146dbd963dc38c4f))
* ignore JSON conversion throw in partial chains output ([742c1c7](https://github.com/jolibrain/deepdetect/commit/742c1c7c307ff5d7ccfdce0f7ea005b2166a35c4))
* missing main in bench.py ([8b8b196](https://github.com/jolibrain/deepdetect/commit/8b8b1968c6df221cdb372b83c6db4e83e490eacd))
* proper cleanup of tensorrt models and services ([d6749d0](https://github.com/jolibrain/deepdetect/commit/d6749d0c55ab731310e3f4c1c316a1c3489083ff))
* put useful informations in case of unexpected exception ([5ab90c7](https://github.com/jolibrain/deepdetect/commit/5ab90c7c2d64b1518dc3f556e4d4701811ab09aa))
* readme table of backends, models and data formats ([f606aa8](https://github.com/jolibrain/deepdetect/commit/f606aa832fefc8ba06e78511585effd7205f111f))
* regression benchmark tool parameter ([3840218](https://github.com/jolibrain/deepdetect/commit/3840218d8035172c681d96abc8872e5922afca0e))
* tensorrt output layer lookup now throws when layer does not exist ([ba7c839](https://github.com/jolibrain/deepdetect/commit/ba7c8398bfc016b9b3224b9f6f132a2178a268d0))
* **csvts/torch:** allow to read csv timeserie directly from query ([76023db](https://github.com/jolibrain/deepdetect/commit/76023db1bfafd02e2da7848b62ebec2efb4edcbd))
* **doc:** update to neural network templates and output connector ([2916daf](https://github.com/jolibrain/deepdetect/commit/2916daf423eea2948e160ced1a3a0ee6775b037e))
* **docker:** don't share apt cache between arch build ([75dc9e9](https://github.com/jolibrain/deepdetect/commit/75dc9e98ecfae303f3272c7881004ee192086f92))
* **graph:** correctly discard dropout ([16409a6](https://github.com/jolibrain/deepdetect/commit/16409a6f0e9429f0ab5d70aa4a79e1f7e994839f))
* **stats:** measure of inference count ([b517910](https://github.com/jolibrain/deepdetect/commit/b517910fed38d56c59c43a6d082e03f7a773486d))
* **timeseries:** do not segfault if no valid files in train/test dir ([1977bba](https://github.com/jolibrain/deepdetect/commit/1977bba73cee43bbaf2e1cb1e1322cc21c0361ea))
* **torch:** add missing header needed in case of building w/o caffe backend ([2563b74](https://github.com/jolibrain/deepdetect/commit/2563b74a0128c0934a0792eb16a50cdd2ff5ecdb))
* **torch:** load weights only once ([0052a03](https://github.com/jolibrain/deepdetect/commit/0052a03027d08ea443a096c6ce0f2d351e19313d))
* **torch:** reload solver params on API device ([30fa16f](https://github.com/jolibrain/deepdetect/commit/30fa16f2e9cf27d5214db77707e3448ab23cc92a))
* tensorrt fp16 and int8 selector ([36c7488](https://github.com/jolibrain/deepdetect/commit/36c7488ee818a780c8d5aa82223c650f3b805316))
* **torch/native:** prevent loading weights before instanciating native model ([b15d767](https://github.com/jolibrain/deepdetect/commit/b15d7672240a6d4261b1cc5ec2f1b7139350eaf3))
* **torch/timeseries:** do not double read query data ([d54f60d](https://github.com/jolibrain/deepdetect/commit/d54f60df9fa453b403d393b87e591294eae29b21))

### 0.10.2 (2020-10-09)


### Features

* **timeseries:** MAPE, sMAPE, MASE, OWA metrics ([c1f4ef9](https://github.com/jolibrain/deepdetect/commit/c1f4ef9fa240556d4ab624bae23443a1d19f539b))
* automatically push image build for master ([19e9674](https://github.com/jolibrain/deepdetect/commit/19e9674897c1933e0dad358b9da17ce9ce5990d2))
* **build:** add script to create cppnet-lib debian package ([28247b4](https://github.com/jolibrain/deepdetect/commit/28247b435e7290fb3297a5ce90731f33f0f6fc71))
* **build:** allow to change CUDA_ARCH ([67ad43e](https://github.com/jolibrain/deepdetect/commit/67ad43e0079fa3e3beee73158a737f8b14b3f1ce))
* **dede:** Training for image classification with torch ([6e81915](https://github.com/jolibrain/deepdetect/commit/6e81915128c0c6b9d9a20184a119fd861b5e696e))
* **docker:** publish image as soon as ready ([957e07c](https://github.com/jolibrain/deepdetect/commit/957e07c9fe02ca6f92a4af72d9fc6be236af0a8d))
* **docker:** publish image as soon as ready ([5f7013d](https://github.com/jolibrain/deepdetect/commit/5f7013d17a2ab6ebd452f2642ef1bd252de93154))
* **docker:** rework Dockerfile ([8bc9ddf](https://github.com/jolibrain/deepdetect/commit/8bc9ddf6d9f5dbc9035f0a8198f8d2fb353f7aa0))
* **docker:** use prebuild cppnet-lib ([c929773](https://github.com/jolibrain/deepdetect/commit/c92977350cabbc1a180e11104ad141105d2231a1))
* **graph:** lstm autoencoder ([038a74c](https://github.com/jolibrain/deepdetect/commit/038a74c4f79c38e689108a113a944edc54d4e763))
* **nbeats:** expose hidden size param in API ([d7e5515](https://github.com/jolibrain/deepdetect/commit/d7e5515aaa428d1767fcc720483d9c5034f17022))
* add auto release tools ([98b41b0](https://github.com/jolibrain/deepdetect/commit/98b41b037f1bb8aaea4b1bba8910ee273b7ab08b))
* **imginputfile:** histogram equalization of input image ([2f0061c](https://github.com/jolibrain/deepdetect/commit/2f0061caf939e9cd4efeeac0cdfa5df7269970dd)), closes [#778](https://github.com/jolibrain/deepdetect/issues/778)
* **imginputfile:** histogram equalization of input image ([576f2d8](https://github.com/jolibrain/deepdetect/commit/576f2d8a966035425f58509a1888412c3c6acdd2)), closes [#778](https://github.com/jolibrain/deepdetect/issues/778)
* **stats:** added service statistics mechanism ([1839e4a](https://github.com/jolibrain/deepdetect/commit/1839e4a3451a9d6cab6025c0a5face956817cc70))
* **torch:** in case of timeseries, warn if file do not contain enough timesteps ([1a5f905](https://github.com/jolibrain/deepdetect/commit/1a5f9059a6551182384101af039a8be04237edd4))
* **torch:** nbeats ([f288665](https://github.com/jolibrain/deepdetect/commit/f2886654240ed3921cb9ea571b4812323a1cb8c8))
* **torch:** upgrade to torch 1.6 ([f8f7dbb](https://github.com/jolibrain/deepdetect/commit/f8f7dbbd9854e5f0459e340badf3e1d1994c211f))
* **torch,native:** extract_layer ([d37e182](https://github.com/jolibrain/deepdetect/commit/d37e182040fddda7eb0a7a9a6190ea4f79b8aa3d))
* add json output to dd_bench.py ([874fc01](https://github.com/jolibrain/deepdetect/commit/874fc0142eae604013cbff48d341cef402b55fdd))
* added bw image input support to dd_bench ([6e558d6](https://github.com/jolibrain/deepdetect/commit/6e558d61e5da4dbd1ac92f9029a20b669c84354c))
* **trains-status:** add tflops to body.measures ([af31c8b](https://github.com/jolibrain/deepdetect/commit/af31c8bda0285eb778ccbf378be38e82f6f68895)), closes [#785](https://github.com/jolibrain/deepdetect/issues/785)
* Docker images optimization ([fba637a](https://github.com/jolibrain/deepdetect/commit/fba637a7c70ddb8e73c2bdd2850e6daea36259f0))
* format the code with clang-format ([07d6bdc](https://github.com/jolibrain/deepdetect/commit/07d6bdc0227ed2f799942e6c7eb80690c8a2a16f))
* LSTM over torch , preliminary internal graph representation ([25faa8b](https://github.com/jolibrain/deepdetect/commit/25faa8bcf3d0eff6aec27642e53d67580866850a))
* update all docker images to ubuntu 18.04 ([eaf0421](https://github.com/jolibrain/deepdetect/commit/eaf04210642fa22696d1b1fa0af1e7b9e9d25c2f))


### Bug Fixes

* fix split_data in csvts connector ([8f554b5](https://github.com/jolibrain/deepdetect/commit/8f554b510e4cb7ee4df1e56c54d0bf6358e74ab4))
* **build:** CUDA_ARCH not escaped correctly ([696087f](https://github.com/jolibrain/deepdetect/commit/696087f4cafe4be555ee1b37a1587f37e67d4383))
* **build:** ensure all xgboost submodules are checkouted ([12aaa1a](https://github.com/jolibrain/deepdetect/commit/12aaa1af8ca80b82948d5b12f71582adfda1c0d1))
* **clang-format:** signed/unsigned comparaison ([af8e144](https://github.com/jolibrain/deepdetect/commit/af8e144f5ae0f8667775d837096bd3fa27ed766c))
* **clang-format:** signed/unsigned comparaison ([0ccabb6](https://github.com/jolibrain/deepdetect/commit/0ccabb62ca97008816760714e057f600befc5c1c))
* **clang-format:** typo in dataset tarball command ([04ddad7](https://github.com/jolibrain/deepdetect/commit/04ddad7820612f8ae82cc8daff4a3c14ea01a79d))
* **csvts:** correctly store and print test file names ([12d4639](https://github.com/jolibrain/deepdetect/commit/12d4639a06b26b4fc5edd36a6ed86d04633f8bed))
* **dede:** Remove unnecessary caffe include that prevent build with torch only ([a471b82](https://github.com/jolibrain/deepdetect/commit/a471b82c79b732a2c0dea6dfd675b2d0419e343c))
* **dede:** support all version of spdlog while building with syslog ([81f47c9](https://github.com/jolibrain/deepdetect/commit/81f47c9101be8ba5e24ac2206d623db1c9f605c8))
* **docker:** add missing .so at runtime ([4cc24ce](https://github.com/jolibrain/deepdetect/commit/4cc24ceb5f2c1a8c214a6795fc7fe46f7e4ea0d6))
* **docker:** add missing gpu_tensorrt.Dockerfile ([97ff2b3](https://github.com/jolibrain/deepdetect/commit/97ff2b3ec4fc447810eacabcb9ebde0091ff10cc))
* **docker:** add some missing runtime deps ([0883a33](https://github.com/jolibrain/deepdetect/commit/0883a33f95f75bff473197e4a0fd24bffc9a0e58))
* **docker:** add some missing runtime deps ([a91f35f](https://github.com/jolibrain/deepdetect/commit/a91f35f3e4669be16b0c602cb4169d272321c97f))
* **docker:** fixup base runtime image ([6238dd4](https://github.com/jolibrain/deepdetect/commit/6238dd4698c9ea674852bf895384ec7ed75f0c8b))
* **docker:** install rapidjson-dev package ([30fb2ca](https://github.com/jolibrain/deepdetect/commit/30fb2caf7971343213335e98100d3e2e8df697f9))
* **native:** do not raise exception if no template_param is given ([d0705ab](https://github.com/jolibrain/deepdetect/commit/d0705abf53d5982a8f660f9a3c6e74687630b2d7))
* **nbeats:** correctly setup trend and seasonality models (implement paper version and not code version) ([75accc6](https://github.com/jolibrain/deepdetect/commit/75accc61516890ebc4ef8f15d9e44bbc0c4b3376))
* **nbeats:** much lower memory use in case of large dim signals ([639e222](https://github.com/jolibrain/deepdetect/commit/639e22285e7a0ce907ff3e2368d0840b5763dbf8))
* **tests:** inc iteration of torchapi.service_train_image test ([4c93ace](https://github.com/jolibrain/deepdetect/commit/4c93ace24e8c3c5161bacdb2b6dad40ff87aa445))
* **torch:** Fix conditions to add classification head. ([f46a710](https://github.com/jolibrain/deepdetect/commit/f46a710d9b1c1f28774c1985bc4450386587ca95))
* **torch/timeseries:** unscale prediction output if needed ([aa30e88](https://github.com/jolibrain/deepdetect/commit/aa30e88a22d526d25361c40919e6ec4c5de90f6a))
* /api/ alias when deployed on deepdetect.com ([4736893](https://github.com/jolibrain/deepdetect/commit/4736893614b0678af04254ffe2923c3a51b03350))
* add support and automated processing of categorical variables in timeseries data ([1a9af3e](https://github.com/jolibrain/deepdetect/commit/1a9af3e32a8627d03b305676177ef46ed527aaa5))
* allow serialization/deserializationt of Inf/-Inf/NaN ([976c892](https://github.com/jolibrain/deepdetect/commit/976c892d3326b80c69e708ae20763df59c6d41ca))
* allows to specify size and color/bw with segmentation models ([58ecb4a](https://github.com/jolibrain/deepdetect/commit/58ecb4a2b772ed48ca690095d957c0e10fb61550))
* build with -DUSE_TENSORRT_OSS=ON ([39bd675](https://github.com/jolibrain/deepdetect/commit/39bd67524aa3d455c348656605cc50f0b1b5b719))
* convolution layer initialization of SE-ResNeXt network templates ([69ff0fb](https://github.com/jolibrain/deepdetect/commit/69ff0fb2b0e3755b0dfc26796e2a10a16b787b8f))
* in tensorrt builds, remove forced cuda version and unused lib output + force-select tensorrt when tensorrt_oss is selected ([9430fb4](https://github.com/jolibrain/deepdetect/commit/9430fb40b6924d57d43b602f35686f688c6afe3e))
* input image transforms in API doc ([f513f17](https://github.com/jolibrain/deepdetect/commit/f513f1750173ae76971185d5e04410091fba41e0))
* install cmake version 3.10 ([10666b8](https://github.com/jolibrain/deepdetect/commit/10666b81d734678916360b73e8fcf38d5321cdea))
* missing variant package in docker files ([dcf738b](https://github.com/jolibrain/deepdetect/commit/dcf738bdad357ef4762cfe12f60fcfc844a516ac))
* race condition in xgboost|dede build ([fd32eae](https://github.com/jolibrain/deepdetect/commit/fd32eae643884f92c47ee27ab5ece42980ae2221))
* remove unecessary limit setting call to protobuf codedstream ([ae26f59](https://github.com/jolibrain/deepdetect/commit/ae26f59651b8e725b67f9f301664683c94af5b95))
* replace db":true by db":false in json files when copying models ([06ac6df](https://github.com/jolibrain/deepdetect/commit/06ac6dfb38a943de351e64bf6d26041df07147ab))
* set caffe smooth l1 loss threshold to 1 ([0e329f0](https://github.com/jolibrain/deepdetect/commit/0e329f08803f12c7df03bf555594ddd0b84b467f))
* ssd_300_res_128 deploy file is missing a quote ([4e52a0e](https://github.com/jolibrain/deepdetect/commit/4e52a0e66f74050811f882508c7eacae11fdc3d5))
* svm prediction with alll db combinations ([d8e2961](https://github.com/jolibrain/deepdetect/commit/d8e2961bf970243052421bd1d7000bcf08e72bed))
* svm with db training ([6e925f2](https://github.com/jolibrain/deepdetect/commit/6e925f2bb0a19633b408dca1d457a246acdd4c52))
* tensorrt does not support blank_label ([7916500](https://github.com/jolibrain/deepdetect/commit/7916500876d8acab85c3f49010cfc49faa8a9186))
* typo in docker image builder ([cb5ae19](https://github.com/jolibrain/deepdetect/commit/cb5ae19b3674936281a5f6ce1959a665f09c04cd))
* unusual builds (ie w/o torch or with tsne only lead to build errors ([241bf6b](https://github.com/jolibrain/deepdetect/commit/241bf6b2cd5cf4db0ccb144152557c3c1fed2776))
* update caffe cudnn engine without template ([ca58c51](https://github.com/jolibrain/deepdetect/commit/ca58c51618b759a254c0d479e5d0e458197676a0))
* **torch:** handle case where sequence data is < wanted timestep ([b6d394a](https://github.com/jolibrain/deepdetect/commit/b6d394ac229993e21f557d58a70116823fe75a6b))
* **TRT:** refinedet ([b6152b6](https://github.com/jolibrain/deepdetect/commit/b6152b6bdc0d7f6b77a253b1c0f9a96d0fcedd7f))

### 0.9.7 (2020-04-18)

### 0.9.6 (2020-02-05)

### 0.9.5 (2019-12-30)

### 0.9.4 (2019-10-22)

### 0.9.3 (2019-08-27)


### Bug Fixes

* caffe solver selection ([c45abfc](https://github.com/jolibrain/deepdetect/commit/c45abfc8c769b10123113d96ac497950f6d4f5da))

### 0.9.2 (2019-08-02)


### Bug Fixes

* do not segfault when cannot find ncnn model files ([6aee195](https://github.com/jolibrain/deepdetect/commit/6aee195c9db4fe723e79b9505bee37a4ae4f39d7))

### 0.9.1 (2019-06-30)

## 0.9.0 (2019-05-09)


### Bug Fixes

* compilation race issue. ([4e16c56](https://github.com/jolibrain/deepdetect/commit/4e16c565a3ce5584260aad119e4ccf3f96c61528))
* deps issue for NCNN ([22f40bd](https://github.com/jolibrain/deepdetect/commit/22f40bdd18d861563ce47429718b9cb5dae36fd6))
* do not build tf unit tests when tf not requested in build ([e9974b8](https://github.com/jolibrain/deepdetect/commit/e9974b8df9ed0cb1bf8e62106289bdf263c9bf49))
* issues with hardware_concurrency declaration. ([20d5fe5](https://github.com/jolibrain/deepdetect/commit/20d5fe5b92cab363124fc6f14293d3e57e39e9a9))
* NCNN compilation. ([089b0dc](https://github.com/jolibrain/deepdetect/commit/089b0dceb6fc14787b28c7b9e99033638eb4c057))
* NCNN input issues. ([111269a](https://github.com/jolibrain/deepdetect/commit/111269ae76c9de6ed7a2bc3fdcd391018c369454))
* NCNN service declaration. ([02df07d](https://github.com/jolibrain/deepdetect/commit/02df07d255aadbe500f2644fbc45b365a6929366))
* NCNN service model constructor. ([633bccb](https://github.com/jolibrain/deepdetect/commit/633bccbd50ad19c1bd7fbc88dca31caa09d2ebda))
* small glitch in init, was ok before, but clearer now ([bfd9fa9](https://github.com/jolibrain/deepdetect/commit/bfd9fa92955627bfbb2a43ac1626e6968beff6c3))
* throw error on NCNN extraction fail ([569800a](https://github.com/jolibrain/deepdetect/commit/569800ae9e433911fe7d82928114a2ccd4737ac5))
